/*
 * Copyright (c) 2017 Fraunhofer FOKUS.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the
 * GNU AGPL v3 which accompanies
 * this distribution, and is available at
 * http://www.gnu.org/licenses/agpl.txt
 *
 * Contributors:
 * Simon Dutkowski Fraunhofer FOKUS
 *
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 */
package eu.DECIDEh2020.appManager.models;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;

import java.util.ArrayList;
import java.util.List;

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(Include.NON_EMPTY)
public class Sla {

	private String description;

	private String visibility;

	private Integer validityPeriod;

	private List<String> coveredServices = new ArrayList<>();

	// SLA definitions

	private List<ServiceObjective> objectives = new ArrayList<>();

	// Roles and responsibilities

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getVisibility() {
		return visibility;
	}

	public void setVisibility(String visibility) {
		this.visibility = visibility;
	}

	public Integer getValidityPeriod() {
		return validityPeriod;
	}

	public void setValidityPeriod(Integer validityPeriod) {
		this.validityPeriod = validityPeriod;
	}

	public List<String> getCoveredServices() {
		return coveredServices;
	}

	public void setCoveredServices(List<String> coveredServices) {
		this.coveredServices = coveredServices;
	}

	public List<ServiceObjective> getObjectives() {
		return objectives;
	}

	public void setObjectives(List<ServiceObjective> objectives) {
		this.objectives = objectives;
	}

}
