/*
 * Copyright (c) 2017 Fraunhofer FOKUS.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the
 * GNU AGPL v3 which accompanies
 * this distribution, and is available at
 * http://www.gnu.org/licenses/agpl.txt
 *
 * Contributors:
 * Simon Dutkowski Fraunhofer FOKUS
 *
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 */
package eu.DECIDEh2020.appManager.models;

import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.JsonNode;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class VirtualMachine {

    private String id;

    private String cspId;
    private String cspName;

    private Integer ram;
    private Integer cores;
    private Integer storage;
    private String image;

    private String cloudBrokerEndpoint;
    private String cloudBrokerUsername;
    private String cloudBrokerPassword;

    private String vmSoftwareId;
    private String vmResourceId;
    private String vmRegionId;

    private String instanceTypeId;
    private String keyPairId;

    private List<Integer> openedPorts = new ArrayList<>();

    private String consulJoinIp;
    private String dockerPrivateRegistryIp;
    private Integer dockerPrivateRegistryPPort;

    private String dockerHostNodeName;
    private String dockerHostPublicIp;

    private Map<String, JsonNode> additionalProperties = new HashMap<>();
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getCspId() {
        return cspId;
    }

    public void setCspId(String cspId) {
        this.cspId = cspId;
    }

    public String getCspName() {
        return cspName;
    }

    public void setCspName(String cspName) {
        this.cspName = cspName;
    }

    public Integer getRam() {
        return ram;
    }

    public void setRam(Integer ram) {
        this.ram = ram;
    }

    public Integer getCores() {
        return cores;
    }

    public void setCores(Integer cores) {
        this.cores = cores;
    }

    public Integer getStorage() {
        return storage;
    }

    public void setStorage(Integer storage) {
        this.storage = storage;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public String getCloudBrokerEndpoint() {
        return cloudBrokerEndpoint;
    }

    public void setCloudBrokerEndpoint(String cloudBrokerEndpoint) {
        this.cloudBrokerEndpoint = cloudBrokerEndpoint;
    }

    public String getCloudBrokerUsername() {
        return cloudBrokerUsername;
    }

    public void setCloudBrokerUsername(String cloudBrokerUsername) {
        this.cloudBrokerUsername = cloudBrokerUsername;
    }

    public String getCloudBrokerPassword() {
        return cloudBrokerPassword;
    }

    public void setCloudBrokerPassword(String cloudBrokerPassword) {
        this.cloudBrokerPassword = cloudBrokerPassword;
    }

    public String getVmSoftwareId() {
        return vmSoftwareId;
    }

    public void setVmSoftwareId(String vmSoftwareId) {
        this.vmSoftwareId = vmSoftwareId;
    }

    public String getVmResourceId() {
        return vmResourceId;
    }

    public void setVmResourceId(String vmResourceId) {
        this.vmResourceId = vmResourceId;
    }

    public String getVmRegionId() {
        return vmRegionId;
    }

    public void setVmRegionId(String vmRegionId) {
        this.vmRegionId = vmRegionId;
    }

    public String getInstanceTypeId() {
        return instanceTypeId;
    }

    public void setInstanceTypeId(String instanceTypeId) {
        this.instanceTypeId = instanceTypeId;
    }

    public String getKeyPairId() {
        return keyPairId;
    }

    public void setKeyPairId(String keyPairId) {
        this.keyPairId = keyPairId;
    }

    public List<Integer> getOpenedPorts() {
        return openedPorts;
    }

    public void setOpenedPorts(List<Integer> openedPorts) {
        this.openedPorts = openedPorts;
    }

    public String getConsulJoinIp() {
        return consulJoinIp;
    }

    public void setConsulJoinIp(String consulJoinIp) {
        this.consulJoinIp = consulJoinIp;
    }

    public String getDockerPrivateRegistryIp() {
        return dockerPrivateRegistryIp;
    }

    public void setDockerPrivateRegistryIp(String dockerPrivateRegistryIp) {
        this.dockerPrivateRegistryIp = dockerPrivateRegistryIp;
    }

    public Integer getDockerPrivateRegistryPPort() {
        return dockerPrivateRegistryPPort;
    }

    public void setDockerPrivateRegistryPPort(Integer dockerPrivateRegistryPPort) {
        this.dockerPrivateRegistryPPort = dockerPrivateRegistryPPort;
    }

    public String getDockerHostNodeName() {
        return dockerHostNodeName;
    }

    public void setDockerHostNodeName(String dockerHostNodeName) {
        this.dockerHostNodeName = dockerHostNodeName;
    }

    public String getDockerHostPublicIp() {
        return dockerHostPublicIp;
    }

    public void setDockerHostPublicIp(String dockerHostPublicIp) {
        this.dockerHostPublicIp = dockerHostPublicIp;
    }

    @JsonAnyGetter
    public Map<String, JsonNode> getAdditionalProperties() {
        return additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperties(String property, JsonNode value) {
        additionalProperties.put(property, value);
    }

}
